/** @param {NS} ns */
export async function main(ns) {
	const maxServerCount = ns.getPurchasedServerLimit()
	let serverCount = ns.getPurchasedServers().length

	ns.tprint(`we have ${serverCount} servers`)
	ns.tprint(`we can have ${maxServerCount} servers`)

	if (serverCount < maxServerCount) {
		// create missing servers
		const requestedRAM = 4
		const serverCost = ns.getPurchasedServerCost(requestedRAM)
		ns.tprint(`server cost is ${ns.formatNumber(serverCost)}`)

		while (serverCount < maxServerCount) {
			const serverName = `worker-${serverCount}`
			if (ns.getServerMoneyAvailable("home") >= serverCost) {
				ns.tprint(`racking server ${serverName}`)
				ns.purchaseServer(serverName, requestedRAM)
				serverCount++
			}
			else {
				await ns.sleep(60000)
			}
		}
	}

	ns.tprint("done! spawning auto-upgrade")
	ns.spawn("auto/upgrade-workers.js")

}