/** @param {NS} ns */
export async function main(ns) {
	const servers = ns.getPurchasedServers()

	ns.clearLog()
	ns.tail()
	ns.disableLog('ALL')

	const getLowestServerRAM = () => {
		return Math.min.apply(Math, servers.map(ns.getServerMaxRam))
	}

	while (getLowestServerRAM() < ns.getPurchasedServerMaxRam()) {
		const requestedRAM = getLowestServerRAM()*2
		for (const serverName of servers) {
			const serverRAM = ns.getServerMaxRam(serverName)
			if (serverRAM < requestedRAM) {
				const serverCost = ns.getPurchasedServerUpgradeCost(serverName, requestedRAM)
				ns.print(`selected server ${serverName} to be upgraded (current RAM: ${ns.formatRam(serverRAM)}, upgraded RAM: ${ns.formatRam(requestedRAM)}, upgrade cost: ${ns.formatNumber(serverCost)})`)
				while (true) {
					if (ns.getServerMoneyAvailable("home") >= serverCost) {
						ns.killall(serverName) //TODO: make it more graceful
						ns.upgradePurchasedServer(serverName, requestedRAM)
						break
					}
					else {
						await ns.sleep(60000)
					}
				}
			}
		}
	}
}