/** @param {NS} ns */
export async function main(ns) {
	// ns.clearLog()
	// ns.tail()
	ns.disableLog('ALL')

	const pwnMethods = []
	if (ns.fileExists("BruteSSH.exe")) {
		pwnMethods.push(ns.brutessh)
	}
	if (ns.fileExists("FTPCrack.exe")) {
		pwnMethods.push(ns.ftpcrack)
	}
	if (ns.fileExists("HTTPWorm.exe")) {
		pwnMethods.push(ns.httpworm)
	}
	if (ns.fileExists("relaySMTP.exe")) {
		pwnMethods.push(ns.relaysmtp)
	}
	if (ns.fileExists("SQLInject.exe")) {
		pwnMethods.push(ns.sqlinject)
	}

	const autopwn = (hostnameToAnalyze = "home", serverList = ["home"]) => {
		for (const hostname of ns.scan(hostnameToAnalyze)) {
			// check if we alreay have added this server to the list
			if (!serverList.includes(hostname)) {
				// nuke if able
				if (ns.hasRootAccess(hostname)) {
					ns.print(`already pwned ${hostname}`)
				}
				else if (ns.getServerNumPortsRequired(hostname) <= pwnMethods.length) {
					ns.print(`pwning ${hostname}`)
					for (let i = 0; i < ns.getServerNumPortsRequired(hostname); i++) {
						pwnMethods[i](hostname)
					}
					ns.nuke(hostname)
				}
				else {
					ns.print(`missing requirements to pwn ${hostname}. (${pwnMethods.length} < ${ns.getServerNumPortsRequired(hostname)})`)
				}

				// add to the list
				serverList.push(hostname)
				// pwn childen
				autopwn(hostname, serverList)
			}
		}
	}
	autopwn()
}